searchNodes=[{"doc":"A non-general, purely functional subset of Elixir","ref":"Ethyl.html","title":"Ethyl","type":"module"},{"doc":"Compiles an ethyl reduction This can be used to write ethyl code inline in Elixir code","ref":"Ethyl.html#ethyl/1","title":"Ethyl.ethyl/1","type":"macro"},{"doc":"Evaluates an ethyl expression in the given path with the given context This function is used under the hood by from_elixir_ast/2 when using import . Note that this function calls out to Code.eval_quoted/3 which is potentially dangerous: only use this function if you know ahead of time that the contents of path are safe to evaluate.","ref":"Ethyl.html#eval_file!/4","title":"Ethyl.eval_file!/4","type":"function"},{"doc":"Transpiles an Elixir AST into an Ethyl AST","ref":"Ethyl.html#from_elixir_ast/2","title":"Ethyl.from_elixir_ast/2","type":"function"},{"doc":"A data structure describing the context in which an ethyl expression is defined.","ref":"Ethyl.Context.html","title":"Ethyl.Context","type":"module"},{"doc":"","ref":"Ethyl.Context.html#from_elixir_env/1","title":"Ethyl.Context.from_elixir_env/1","type":"function"},{"doc":"TODO","ref":"Ethyl.Context.html#t:t/0","title":"Ethyl.Context.t/0","type":"type"},{"doc":"Functions for linting Ethyl code","ref":"Ethyl.Lint.html","title":"Ethyl.Lint","type":"behaviour"},{"doc":"Lints a source file against all known linters","ref":"Ethyl.Lint.html#lint/1","title":"Ethyl.Lint.lint/1","type":"function"},{"doc":"","ref":"Ethyl.Lint.html#c:lint/1","title":"Ethyl.Lint.lint/1","type":"callback"},{"doc":"Traverses the AST in search of lint issues This function uses Macro.prewalk/3 under the hood. The traversal_fn must be a function of arity 2 taking the AST and the accumulator as arguments. traversal_fn should return a 2-tuple of {ast, lints}","ref":"Ethyl.Lint.html#traverse/3","title":"Ethyl.Lint.traverse/3","type":"function"},{"doc":"","ref":"Ethyl.Lint.html#t:t/0","title":"Ethyl.Lint.t/0","type":"type"},{"doc":"A linter that catches dynamic applications of functions E.g. binding . function_name ( args )","ref":"Ethyl.Lint.DynamicFunctionApplication.html","title":"Ethyl.Lint.DynamicFunctionApplication","type":"module"},{"doc":"A linter that blocks access to functions that perform impure side-effects","ref":"Ethyl.Lint.MfaAllowlist.html","title":"Ethyl.Lint.MfaAllowlist","type":"module"},{"doc":"An admittedly odd data structure for either invoking functions or accessing submodules This data structure allows one to describe a module hierarchy as a tree of structs without losing any modules.","ref":"Ethyl.ModuleTree.html","title":"Ethyl.ModuleTree","type":"module"},{"doc":"Gets a module within the tree","ref":"Ethyl.ModuleTree.html#module_in/2","title":"Ethyl.ModuleTree.module_in/2","type":"function"},{"doc":"A structure representing a source file containing Ethyl code","ref":"Ethyl.Source.html","title":"Ethyl.Source","type":"module"},{"doc":"","ref":"Ethyl.Source.html#new/1","title":"Ethyl.Source.new/1","type":"function"},{"doc":"","ref":"Ethyl.Source.html#t:t/0","title":"Ethyl.Source.t/0","type":"type"},{"doc":"A task to compile Ethyl expressions into BEAM bytecode Compiling Ethyl expressions may be valuable so that one can measure code coverage with a test suite. The design of this compiler is loosly based on the 1.12 Elixir compiler , but it is adapted for Ethyl's unique structures. Namely, This compiler wraps expressions in superfluous modules. This is necessary to measure coverage with the built-in :cover module.","ref":"Mix.Tasks.Compile.Ethyl.html","title":"Mix.Tasks.Compile.Ethyl","type":"task"},{"doc":"A mix task for running the Ethyl linters against specified files The linter may be run against a single file like so mix ethyl . lint path / to / ethyl / expression . exs Or you may pass a glob which is expanded by your shell mix ethyl . lint path / to / ethyl / * . exs","ref":"Mix.Tasks.Ethyl.Lint.html","title":"Mix.Tasks.Ethyl.Lint","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Ethyl.Lint.html#run/1","title":"Mix.Tasks.Ethyl.Lint.run/1","type":"function"},{"doc":"Changelog All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Added Added a mix task to compile ethyl expressions","ref":"changelog.html#0-2-0-2021-10-25","title":"Changelog - 0.2.0 - 2021-10-25","type":"extras"},{"doc":"Added Initial working version published","ref":"changelog.html#0-1-0-2021-10-06","title":"Changelog - 0.1.0 - 2021-10-06","type":"extras"},{"doc":"Added This project was generated by Gaas","ref":"changelog.html#0-0-0-2021-09-30","title":"Changelog - 0.0.0 - 2021-09-30","type":"extras"}]